Index: /pjproject/main/pjsip/src/pjsip/sip_parser.c
===================================================================
--- /pjproject/main/pjsip/src/pjsip/sip_parser.c	(revision 42)
+++ /pjproject/main/pjsip/src/pjsip/sip_parser.c	(revision 43)
@@ -802,8 +910,8 @@
 				 pj_str_t *user, pj_str_t *pass)
 {
-    pj_scan_get( scanner, pjsip_USER_SPEC, user);
-    if ( *scanner->current == ':') {
+    pj_scan_get( scanner, &pjsip_USER_SPEC, user);
+    if ( *scanner->curptr == ':') {
 	pj_scan_get_char( scanner );
-	pj_scan_get( scanner, pjsip_PASSWD_SPEC, pass);
+	pj_scan_get( scanner, &pjsip_PASSWD_SPEC, pass);
     } else {
 	pass->ptr = NULL;
@@ -816,11 +924,11 @@
 
 /* Parse all types of URI. */
-static pjsip_uri *int_parse_uri_or_name_addr(pj_scanner *scanner, pj_pool_t *pool,
-						  unsigned option)
+static pjsip_uri *int_parse_uri_or_name_addr( pj_scanner *scanner, pj_pool_t *pool,
+					      unsigned opt)
 {
     pjsip_uri *uri;
     int is_name_addr = 0;
 
-    if (*scanner->current=='"' || *scanner->current=='<') {
+    if (*scanner->curptr=='"' || *scanner->curptr=='<') {
 	uri = (pjsip_uri*)int_parse_name_addr( scanner, pool );
 	is_name_addr = 1;
@@ -831,12 +939,15 @@
 
 	pj_scan_save_state( scanner, &backtrack);
-	pj_scan_get( scanner, pjsip_TOKEN_SPEC, &scheme);
+	pj_scan_get( scanner, &pjsip_TOKEN_SPEC, &scheme);
 	colon = pj_scan_get_char( scanner );
 	pj_scan_restore_state( scanner, &backtrack);
 
-	if (colon==':' && (parser_stricmp(scheme, pjsip_SIP_STR)==0 || parser_stricmp(scheme, pjsip_SIPS_STR)==0)) 
+	if (colon==':' && 
+            (parser_stricmp(scheme, pjsip_SIP_STR)==0 || 
+             parser_stricmp(scheme, pjsip_SIPS_STR)==0)) 
 	{
-	    uri = (pjsip_uri*)int_parse_sip_url( scanner, pool, 
-					(option & PJSIP_PARSE_URI_IN_FROM_TO_HDR) == 0 );
+	    uri = (pjsip_uri*)
+                int_parse_sip_url( scanner, pool, 
+				   (opt & PJSIP_PARSE_URI_IN_FROM_TO_HDR)== 0);
 
 	} else if (colon==':' && parser_stricmp( scheme, pjsip_TEL_STR)==0) {
@@ -853,5 +964,5 @@
 
     /* Should we return the URI object as name address? */
-    if (option & PJSIP_PARSE_URI_AS_NAMEADDR) {
+    if (opt & PJSIP_PARSE_URI_AS_NAMEADDR) {
 	if (is_name_addr == 0) {
 	    pjsip_name_addr *name_addr;
@@ -871,5 +982,5 @@
 				pj_bool_t parse_params)
 {
-    if (*scanner->current=='"' || *scanner->current=='<') {
+    if (*scanner->curptr=='"' || *scanner->curptr=='<') {
 	return (pjsip_uri*)int_parse_name_addr( scanner, pool );
     } else {
@@ -878,12 +989,13 @@
 
 	/* Get scheme. */
-	colon = pj_scan_peek(scanner, pjsip_TOKEN_SPEC, &scheme);
+	colon = pj_scan_peek(scanner, &pjsip_TOKEN_SPEC, &scheme);
 	if (colon != ':') {
 	    PJ_THROW(PJSIP_SYN_ERR_EXCEPTION);
 	}
 
-	if ((parser_stricmp(scheme, pjsip_SIP_STR)==0 || parser_stricmp(scheme, pjsip_SIPS_STR)==0)) 
+	if ((parser_stricmp(scheme, pjsip_SIP_STR)==0 || 
+            parser_stricmp(scheme, pjsip_SIPS_STR)==0)) 
 	{
-	    return (pjsip_uri*)int_parse_sip_url( scanner, pool, parse_params );
+	    return (pjsip_uri*)int_parse_sip_url( scanner, pool, parse_params);
 
 	} else if (parser_stricmp(scheme, pjsip_TEL_STR)==0) {
@@ -909,5 +1021,5 @@
     scanner->skip_ws = 0;
 
-    pj_scan_get(scanner, pjsip_TOKEN_SPEC, &scheme);
+    pj_scan_get(scanner, &pjsip_TOKEN_SPEC, &scheme);
     colon = pj_scan_get_char(scanner);
     if (colon != ':') {
@@ -938,5 +1050,5 @@
 
     /* Get URL parameters. */
-    while ( parse_params && *scanner->current == ';' ) {
+    while ( parse_params && *scanner->curptr == ';' ) {
 	pj_str_t pname, pvalue;
 
@@ -949,5 +1061,5 @@
 	    url->method_param = pvalue;
 
-	} else if (!parser_stricmp(pname, pjsip_TRANSPORT_STR) && pvalue.slen) {
+	} else if (!parser_stricmp(pname,pjsip_TRANSPORT_STR) && pvalue.slen) {
 	    url->transport_param = pvalue;
 
@@ -967,6 +1079,7 @@
 
     /* Get header params. */
-    if (parse_params && *scanner->current == '?') {
-	pj_scan_get_until(scanner, pjsip_NEWLINE_OR_EOF_SPEC, &url->header_param);
+    if (parse_params && *scanner->curptr == '?') {
+	pj_scan_get_until(scanner, &pjsip_NEWLINE_OR_EOF_SPEC, 
+                          &url->header_param);
     }
 
@@ -985,8 +1098,8 @@
     name_addr = pjsip_name_addr_create(pool);
 
-    if (*scanner->current == '"') {
+    if (*scanner->curptr == '"') {
 	pj_scan_get_quote( scanner, '"', '"', &name_addr->display);
 
-    } else if (*scanner->current != '<') {
+    } else if (*scanner->curptr != '<') {
 	int next;
 	pj_str_t dummy;
@@ -997,5 +1110,5 @@
 	 * will be parser later.
 	 */
-	next = pj_scan_peek_until(scanner, pjsip_DISPLAY_SCAN_SPEC, &dummy);
+	next = pj_scan_peek_until(scanner, &pjsip_DISPLAY_SCAN_SPEC, &dummy);
 	if (next == '<') {
 	    /* Ok, this is what we're looking for, a display name. */
@@ -1009,5 +1122,5 @@
 
     /* Get the SIP-URL */
-    has_bracket = (*scanner->current == '<');
+    has_bracket = (*scanner->curptr == '<');
     if (has_bracket)
 	pj_scan_get_char(scanner);
@@ -1026,5 +1139,5 @@
     pj_str_t token;
 
-    pj_scan_get( scanner, pjsip_TOKEN_SPEC, &token);
+    pj_scan_get( scanner, &pjsip_TOKEN_SPEC, &token);
     pjsip_method_init_np( &req_line->method, &token);
 
@@ -1046,7 +1159,8 @@
     pj_scan_advance_n( scanner, 7, 1);
 
-    pj_scan_get( scanner, pjsip_DIGIT_SPEC, &token);
+    pj_scan_get( scanner, &pjsip_DIGIT_SPEC, &token);
     status_line->code = pj_strtoul(&token);
-    pj_scan_get_until( scanner, pjsip_NEWLINE_OR_EOF_SPEC, &status_line->reason);
+    pj_scan_get_until( scanner, &pjsip_NEWLINE_OR_EOF_SPEC, 
+                       &status_line->reason);
     pj_scan_get_newline( scanner );
 }
@@ -1057,5 +1171,5 @@
     if (pj_scan_is_eof(scanner)) {
 	;   /* Do nothing. */
-    } else if (*scanner->current == '&') {
+    } else if (*scanner->curptr == '&') {
 	pj_scan_get_char(scanner);
     } else {
@@ -1074,10 +1188,11 @@
 				     pj_scanner *scanner)
 {
-    pj_scan_get_until( scanner, pjsip_ARRAY_ELEMENTS, &hdr->values[0]);
+    pj_scan_get_until( scanner, &pjsip_ARRAY_ELEMENTS, &hdr->values[0]);
     hdr->count++;
 
-    while (*scanner->current == ',') {
+    while (*scanner->curptr == ',') {
 	pj_scan_get_char(scanner);
-	pj_scan_get_until( scanner, pjsip_ARRAY_ELEMENTS, &hdr->values[hdr->count]);
+	pj_scan_get_until( scanner, &pjsip_ARRAY_ELEMENTS, 
+                           &hdr->values[hdr->count]);
 	hdr->count++;
     }
@@ -1089,5 +1204,5 @@
 				      pj_scanner *scanner )
 {
-    pj_scan_get_until( scanner, pjsip_NEWLINE_OR_EOF_SPEC, &hdr->hvalue);
+    pj_scan_get_until( scanner, &pjsip_NEWLINE_OR_EOF_SPEC, &hdr->hvalue);
     parse_hdr_end(scanner);
 }
@@ -1098,5 +1213,5 @@
 {
     pj_str_t tmp;
-    pj_scan_get_until( scanner, pjsip_NEWLINE_OR_EOF_SPEC, &tmp);
+    pj_scan_get_until( scanner, &pjsip_NEWLINE_OR_EOF_SPEC, &tmp);
     hdr->ivalue = pj_strtoul(&tmp);
     parse_hdr_end(scanner);
@@ -1105,29 +1220,30 @@
 
 /* Parse Accept header. */
-static pjsip_accept_hdr* parse_hdr_accept( pj_scanner *scanner, 
-					    pj_pool_t *pool)
-{
-    pjsip_accept_hdr *accept = pjsip_accept_hdr_create(pool);
-    parse_generic_array_hdr(accept, scanner);
-    return accept;
+static pjsip_hdr* parse_hdr_accept(pjsip_parse_ctx *ctx)
+{
+    pjsip_accept_hdr *accept = pjsip_accept_hdr_create(ctx->pool);
+    parse_generic_array_hdr(accept, ctx->scanner);
+    return (pjsip_hdr*)accept;
 }
 
 /* Parse Allow header. */
-static pjsip_allow_hdr*   parse_hdr_allow( pj_scanner *scanner, 
-					   pj_pool_t *pool)
-{
-    pjsip_allow_hdr *allow = pjsip_allow_hdr_create(pool);
-    parse_generic_array_hdr(allow, scanner);
-    return allow;
+static pjsip_hdr* parse_hdr_allow(pjsip_parse_ctx *ctx)
+{
+    pjsip_allow_hdr *allow = pjsip_allow_hdr_create(ctx->pool);
+    parse_generic_array_hdr(allow, ctx->scanner);
+    return (pjsip_hdr*)allow;
 }
 
 /* Parse Call-ID header. */
-static pjsip_cid_hdr* parse_hdr_call_id( pj_scanner *scanner, 
-					  pj_pool_t *pool)
-{
-    pjsip_cid_hdr *hdr = pjsip_cid_hdr_create(pool);
-    pj_scan_get_until( scanner, pjsip_NEWLINE_OR_EOF_SPEC, &hdr->id);
-    parse_hdr_end(scanner);
-    return hdr;
+static pjsip_hdr* parse_hdr_call_id(pjsip_parse_ctx *ctx)
+{
+    pjsip_cid_hdr *hdr = pjsip_cid_hdr_create(ctx->pool);
+    pj_scan_get_until( ctx->scanner, &pjsip_NEWLINE_OR_EOF_SPEC, &hdr->id);
+    parse_hdr_end(ctx->scanner);
+
+    if (ctx->rdata)
+        ctx->rdata->call_id = hdr->id;
+
+    return (pjsip_hdr*)hdr;
 }
 
@@ -1137,5 +1253,5 @@
 				     pj_pool_t *pool)
 {
-    while ( *scanner->current == ';' ) {
+    while ( *scanner->curptr == ';' ) {
 	pj_str_t pname, pvalue;
 
@@ -1160,11 +1276,11 @@
 
 /* Parse Contact header. */
-PJ_DEF(pjsip_contact_hdr*) parse_hdr_contact( pj_scanner *scanner, 
-					      pj_pool_t *pool)
+static pjsip_hdr* parse_hdr_contact( pjsip_parse_ctx *ctx )
 {
     pjsip_contact_hdr *first = NULL;
+    pj_scanner *scanner = ctx->scanner;
     
     do {
-	pjsip_contact_hdr *hdr = pjsip_contact_hdr_create(pool);
+	pjsip_contact_hdr *hdr = pjsip_contact_hdr_create(ctx->pool);
 	if (first == NULL)
 	    first = hdr;
@@ -1172,5 +1288,5 @@
 	    pj_list_insert_before(first, hdr);
 
-	if (*scanner->current == '*') {
+	if (*scanner->curptr == '*') {
 	    pj_scan_get_char(scanner);
 	    hdr->star = 1;
@@ -1178,10 +1294,11 @@
 	} else {
 	    hdr->star = 0;
-	    hdr->uri = int_parse_uri_or_name_addr(scanner, pool, PJSIP_PARSE_URI_AS_NAMEADDR);
-
-	    int_parse_contact_param(hdr, scanner, pool);
-	}
-
-	if (*scanner->current != ',')
+	    hdr->uri = int_parse_uri_or_name_addr(scanner, ctx->pool, 
+                                                  PJSIP_PARSE_URI_AS_NAMEADDR);
+
+	    int_parse_contact_param(hdr, scanner, ctx->pool);
+	}
+
+	if (*scanner->curptr != ',')
 	    break;
 
@@ -1191,70 +1308,80 @@
 
     parse_hdr_end(scanner);
-    return first;
+
+    return (pjsip_hdr*)first;
 }
 
 /* Parse Content-Length header. */
-PJ_DEF(pjsip_clen_hdr*) parse_hdr_content_length( pj_scanner *scanner, 
-					          pj_pool_t *pool)
+static pjsip_hdr* parse_hdr_content_len( pjsip_parse_ctx *ctx )
 {
     pj_str_t digit;
     pjsip_clen_hdr *hdr;
 
-    hdr = pjsip_clen_hdr_create(pool);
-    pj_scan_get(scanner, pjsip_DIGIT_SPEC, &digit);
+    hdr = pjsip_clen_hdr_create(ctx->pool);
+    pj_scan_get(ctx->scanner, &pjsip_DIGIT_SPEC, &digit);
     hdr->len = pj_strtoul(&digit);
-    parse_hdr_end(scanner);
-    return hdr;
+    parse_hdr_end(ctx->scanner);
+
+    if (ctx->rdata)
+        ctx->rdata->clen = hdr;
+
+    return (pjsip_hdr*)hdr;
 }
 
 /* Parse Content-Type header. */
-PJ_DEF(pjsip_ctype_hdr*) parse_hdr_content_type( pj_scanner *scanner, 
-					         pj_pool_t *pool)
+static pjsip_hdr* parse_hdr_content_type( pjsip_parse_ctx *ctx )
 {
     pjsip_ctype_hdr *hdr;
-
-    hdr = pjsip_ctype_hdr_create(pool);
+    pj_scanner *scanner = ctx->scanner;
+
+    hdr = pjsip_ctype_hdr_create(ctx->pool);
     
     /* Parse media type and subtype. */
-    pj_scan_get(scanner, pjsip_TOKEN_SPEC, &hdr->media.type);
+    pj_scan_get(scanner, &pjsip_TOKEN_SPEC, &hdr->media.type);
     pj_scan_get_char(scanner);
-    pj_scan_get(scanner, pjsip_TOKEN_SPEC, &hdr->media.subtype);
+    pj_scan_get(scanner, &pjsip_TOKEN_SPEC, &hdr->media.subtype);
 
     /* Parse media parameters */
-    while (*scanner->current == ';') {
+    while (*scanner->curptr == ';') {
 	pj_str_t pname, pvalue;
 	int_parse_param(scanner, &pname, &pvalue);
-	concat_param(&hdr->media.param, pool, &pname, &pvalue);
-    }
-
-    parse_hdr_end(scanner);
-    return hdr;
+	concat_param(&hdr->media.param, ctx->pool, &pname, &pvalue);
+    }
+
+    parse_hdr_end(ctx->scanner);
+
+    if (ctx->rdata)
+        ctx->rdata->ctype = hdr;
+
+    return (pjsip_hdr*)hdr;
 }
 
 /* Parse CSeq header. */
-PJ_DEF(pjsip_cseq_hdr*) parse_hdr_cseq( pj_scanner *scanner, 
-				        pj_pool_t *pool)
+static pjsip_hdr* parse_hdr_cseq( pjsip_parse_ctx *ctx )
 {
     pj_str_t cseq, method;
     pjsip_cseq_hdr *hdr;
 
-    hdr = pjsip_cseq_hdr_create(pool);
-    pj_scan_get( scanner, pjsip_DIGIT_SPEC, &cseq);
+    hdr = pjsip_cseq_hdr_create(ctx->pool);
+    pj_scan_get( ctx->scanner, &pjsip_DIGIT_SPEC, &cseq);
     hdr->cseq = pj_strtoul(&cseq);
 
-    pj_scan_get( scanner, pjsip_TOKEN_SPEC, &method);
+    pj_scan_get( ctx->scanner, &pjsip_TOKEN_SPEC, &method);
     pjsip_method_init_np(&hdr->method, &method);
 
-    parse_hdr_end( scanner );
-    return hdr;
+    parse_hdr_end( ctx->scanner );
+
+    if (ctx->rdata)
+        ctx->rdata->cseq = hdr;
+
+    return (pjsip_hdr*)hdr;
 }
 
 /* Parse Expires header. */
-static pjsip_expires_hdr* parse_hdr_expires(pj_scanner *scanner, 
-					    pj_pool_t *pool)
-{
-    pjsip_expires_hdr *hdr = pjsip_expires_hdr_create(pool);
-    parse_generic_int_hdr(hdr, scanner);
-    return hdr;
+static pjsip_hdr* parse_hdr_expires(pjsip_parse_ctx *ctx)
+{
+    pjsip_expires_hdr *hdr = pjsip_expires_hdr_create(ctx->pool);
+    parse_generic_int_hdr(hdr, ctx->scanner);
+    return (pjsip_hdr*)hdr;
 }
 
@@ -1268,5 +1395,5 @@
 					  PJSIP_PARSE_URI_IN_FROM_TO_HDR);
 
-    while ( *scanner->current == ';' ) {
+    while ( *scanner->curptr == ';' ) {
 	pj_str_t pname, pvalue;
 
@@ -1285,57 +1412,62 @@
 
 /* Parse From: header. */
-PJ_DEF(pjsip_from_hdr*) parse_hdr_from( pj_scanner *scanner, 
-				        pj_pool_t *pool)
-{
-    pjsip_from_hdr *hdr = pjsip_from_hdr_create(pool);
-    parse_hdr_fromto(scanner, pool, hdr);
-    return hdr;
+static pjsip_hdr* parse_hdr_from( pjsip_parse_ctx *ctx )
+{
+    pjsip_from_hdr *hdr = pjsip_from_hdr_create(ctx->pool);
+    parse_hdr_fromto(ctx->scanner, ctx->pool, hdr);
+    if (ctx->rdata)
+        ctx->rdata->from = hdr;
+
+    return (pjsip_hdr*)hdr;
 }
 
 /* Parse Require: header. */
-static pjsip_require_hdr* parse_hdr_require( pj_scanner *scanner, 
-					     pj_pool_t *pool)
-{
-    pjsip_require_hdr *hdr = pjsip_require_hdr_create(pool);
-    parse_generic_array_hdr(hdr, scanner);
-    return hdr;
+static pjsip_hdr* parse_hdr_require( pjsip_parse_ctx *ctx )
+{
+    pjsip_require_hdr *hdr = pjsip_require_hdr_create(ctx->pool);
+    parse_generic_array_hdr(hdr, ctx->scanner);
+
+    if (ctx->rdata && ctx->rdata->require == NULL)
+        ctx->rdata->require = hdr;
+
+    return (pjsip_hdr*)hdr;
 }
 
 /* Parse Retry-After: header. */
-static pjsip_retry_after_hdr* parse_hdr_retry_after(pj_scanner *scanner, 
-						    pj_pool_t *pool)
+static pjsip_hdr* parse_hdr_retry_after(pjsip_parse_ctx *ctx)
 {
     pjsip_retry_after_hdr *hdr;
-    hdr = pjsip_retry_after_hdr_create(pool);
-    parse_generic_int_hdr(hdr, scanner);
-    return hdr;
+    hdr = pjsip_retry_after_hdr_create(ctx->pool);
+    parse_generic_int_hdr(hdr, ctx->scanner);
+    return (pjsip_hdr*)hdr;
 }
 
 /* Parse Supported: header. */
-static pjsip_supported_hdr* parse_hdr_supported(pj_scanner *scanner, 
-						pj_pool_t *pool)
-{
-    pjsip_supported_hdr *hdr = pjsip_supported_hdr_create(pool);
-    parse_generic_array_hdr(hdr, scanner);
-    return hdr;
+static pjsip_hdr* parse_hdr_supported(pjsip_parse_ctx *ctx)
+{
+    pjsip_supported_hdr *hdr = pjsip_supported_hdr_create(ctx->pool);
+    parse_generic_array_hdr(hdr, ctx->scanner);
+    return (pjsip_hdr*)hdr;
 }
 
 
 /* Parse To: header. */
-PJ_DEF(pjsip_to_hdr*) parse_hdr_to( pj_scanner *scanner, 
-				    pj_pool_t *pool)
-{
-    pjsip_to_hdr *hdr = pjsip_to_hdr_create(pool);
-    parse_hdr_fromto(scanner, pool, hdr);
-    return hdr;
+static pjsip_hdr* parse_hdr_to( pjsip_parse_ctx *ctx )
+{
+    pjsip_to_hdr *hdr = pjsip_to_hdr_create(ctx->pool);
+    parse_hdr_fromto(ctx->scanner, ctx->pool, hdr);
+
+    if (ctx->rdata)
+        ctx->rdata->to = hdr;
+
+    return (pjsip_hdr*)hdr;
 }
 
 /* Parse Unsupported: header. */
-static pjsip_unsupported_hdr* parse_hdr_unsupported(pj_scanner *scanner, 
-						    pj_pool_t *pool)
-{
-    pjsip_unsupported_hdr *hdr = pjsip_unsupported_hdr_create(pool);
-    parse_generic_array_hdr(hdr, scanner);
-    return hdr;
+static pjsip_hdr* parse_hdr_unsupported(pjsip_parse_ctx *ctx)
+{
+    pjsip_unsupported_hdr *hdr = pjsip_unsupported_hdr_create(ctx->pool);
+    parse_generic_array_hdr(hdr, ctx->scanner);
+    return (pjsip_hdr*)hdr;
 }
 
@@ -1344,5 +1476,5 @@
 				 pj_pool_t *pool)
 {
-    while ( *scanner->current == ';' ) {
+    while ( *scanner->curptr == ';' ) {
 	pj_str_t pname, pvalue;
 
@@ -1374,21 +1506,23 @@
 
 /* Parse Max-Forwards header. */
-static pjsip_max_forwards_hdr* parse_hdr_max_forwards( pj_scanner *scanner, 
-						       pj_pool_t *pool)
+static pjsip_hdr* parse_hdr_max_forwards( pjsip_parse_ctx *ctx )
 {
     pjsip_max_forwards_hdr *hdr;
-    hdr = pjsip_max_forwards_hdr_create(pool);
-    parse_generic_int_hdr(hdr, scanner);
-    return hdr;
+    hdr = pjsip_max_forwards_hdr_create(ctx->pool);
+    parse_generic_int_hdr(hdr, ctx->scanner);
+
+    if (ctx->rdata)
+        ctx->rdata->max_fwd = hdr;
+
+    return (pjsip_hdr*)hdr;
 }
 
 /* Parse Min-Expires header. */
-static pjsip_min_expires_hdr*  parse_hdr_min_expires(pj_scanner *scanner, 
-						     pj_pool_t *pool)
+static pjsip_hdr* parse_hdr_min_expires(pjsip_parse_ctx *ctx)
 {
     pjsip_min_expires_hdr *hdr;
-    hdr = pjsip_min_expires_hdr_create(pool);
-    parse_generic_int_hdr(hdr, scanner);
-    return hdr;
+    hdr = pjsip_min_expires_hdr_create(ctx->pool);
+    parse_generic_int_hdr(hdr, ctx->scanner);
+    return (pjsip_hdr*)hdr;
 }
 
@@ -1401,16 +1535,18 @@
 
     pj_memcpy(&hdr->name_addr, temp, sizeof(*temp));
-    if (*scanner->current == ';') {
-	pj_scan_get_until(scanner, pjsip_NEWLINE_OR_EOF_SPEC, &hdr->other_param);
+    if (*scanner->curptr == ';') {
+	pj_scan_get_until(scanner, &pjsip_NEWLINE_OR_EOF_SPEC, 
+                          &hdr->other_param);
     }
 }
 
 /* Parse Record-Route header. */
-PJ_DEF(pjsip_rr_hdr*) parse_hdr_rr( pj_scanner *scanner, pj_pool_t *pool)
+static pjsip_hdr* parse_hdr_rr( pjsip_parse_ctx *ctx)
 {
     pjsip_rr_hdr *first = NULL;
+    pj_scanner *scanner = ctx->scanner;
 
     do {
-	pjsip_rr_hdr *hdr = pjsip_rr_hdr_create(pool);
+	pjsip_rr_hdr *hdr = pjsip_rr_hdr_create(ctx->pool);
 	if (!first) {
 	    first = hdr;
@@ -1418,6 +1554,6 @@
 	    pj_list_insert_before(first, hdr);
 	}
-	parse_hdr_rr_route(scanner, pool, hdr);
-	if (*scanner->current == ',') {
+	parse_hdr_rr_route(scanner, ctx->pool, hdr);
+	if (*scanner->curptr == ',') {
 	    pj_scan_get_char(scanner);
 	} else {
@@ -1426,15 +1562,19 @@
     } while (1);
     parse_hdr_end(scanner);
-    return first;
+
+    if (ctx->rdata && ctx->rdata->record_route==NULL)
+        ctx->rdata->record_route = first;
+
+    return (pjsip_hdr*)first;
 }
 
 /* Parse Route: header. */
-PJ_DEF(pjsip_route_hdr*) parse_hdr_route( pj_scanner *scanner, 
-					  pj_pool_t *pool)
+static pjsip_hdr* parse_hdr_route( pjsip_parse_ctx *ctx )
 {
     pjsip_route_hdr *first = NULL;
+    pj_scanner *scanner = ctx->scanner;
 
     do {
-	pjsip_route_hdr *hdr = pjsip_route_hdr_create(pool);
+	pjsip_route_hdr *hdr = pjsip_route_hdr_create(ctx->pool);
 	if (!first) {
 	    first = hdr;
@@ -1442,6 +1582,6 @@
 	    pj_list_insert_before(first, hdr);
 	}
-	parse_hdr_rr_route(scanner, pool, hdr);
-	if (*scanner->current == ',') {
+	parse_hdr_rr_route(scanner, ctx->pool, hdr);
+	if (*scanner->curptr == ',') {
 	    pj_scan_get_char(scanner);
 	} else {
@@ -1450,14 +1590,19 @@
     } while (1);
     parse_hdr_end(scanner);
-    return first;
+
+    if (ctx->rdata && ctx->rdata->route==NULL)
+        ctx->rdata->route = first;
+
+    return (pjsip_hdr*)first;
 }
 
 /* Parse Via: header. */
-PJ_DEF(pjsip_via_hdr*) parse_hdr_via( pj_scanner *scanner, pj_pool_t *pool)
+static pjsip_hdr* parse_hdr_via( pjsip_parse_ctx *ctx )
 {
     pjsip_via_hdr *first = NULL;
+    pj_scanner *scanner = ctx->scanner;
 
     do {
-	pjsip_via_hdr *hdr = pjsip_via_hdr_create(pool);
+	pjsip_via_hdr *hdr = pjsip_via_hdr_create(ctx->pool);
 	if (!first)
 	    first = hdr;
@@ -1470,11 +1615,11 @@
 	pj_scan_advance_n( scanner, 8, 1);
 
-	pj_scan_get( scanner, pjsip_TOKEN_SPEC, &hdr->transport);
-	pj_scan_get( scanner, pjsip_HOST_SPEC, &hdr->sent_by.host);
-
-	if (*scanner->current==':') {
+	pj_scan_get( scanner, &pjsip_TOKEN_SPEC, &hdr->transport);
+	pj_scan_get( scanner, &pjsip_HOST_SPEC, &hdr->sent_by.host);
+
+	if (*scanner->curptr==':') {
 	    pj_str_t digit;
 	    pj_scan_get_char(scanner);
-	    pj_scan_get(scanner, pjsip_DIGIT_SPEC, &digit);
+	    pj_scan_get(scanner, &pjsip_DIGIT_SPEC, &digit);
 	    hdr->sent_by.port = pj_strtoul(&digit);
 	} else {
@@ -1482,7 +1627,7 @@
 	}
 	
-	int_parse_via_param(hdr, scanner, pool);
-
-	if (*scanner->current == '(') {
+	int_parse_via_param(hdr, scanner, ctx->pool);
+
+	if (*scanner->curptr == '(') {
 	    pj_scan_get_char(scanner);
 	    pj_scan_get_until_ch( scanner, ')', &hdr->comment);
@@ -1490,5 +1635,5 @@
 	}
 
-	if (*scanner->current != ',')
+	if (*scanner->curptr != ',')
 	    break;
 
@@ -1498,16 +1643,19 @@
 
     parse_hdr_end(scanner);
-    return first;
+
+    if (ctx->rdata && ctx->rdata->via == NULL)
+        ctx->rdata->via = first;
+
+    return (pjsip_hdr*)first;
 }
 
 /* Parse generic header. */
-PJ_DEF(pjsip_generic_string_hdr*) parse_hdr_generic_string( pj_scanner *scanner, 
-						pj_pool_t *pool)
+static pjsip_hdr* parse_hdr_generic_string( pjsip_parse_ctx *ctx )
 {
     pjsip_generic_string_hdr *hdr;
 
-    hdr = pjsip_generic_string_hdr_create(pool, NULL);
-    parse_generic_string_hdr(hdr, scanner);
-    return hdr;
+    hdr = pjsip_generic_string_hdr_create(ctx->pool, NULL);
+    parse_generic_string_hdr(hdr, ctx->scanner);
+    return (pjsip_hdr*)hdr;
 
 }
@@ -1519,20 +1667,25 @@
     pj_scanner scanner;
     pjsip_hdr *hdr = NULL;
+    pjsip_parse_ctx context;
     PJ_USE_EXCEPTION;
 
     init_sip_parser();
 
-    pj_scan_init(&scanner, buf, size, PJ_SCAN_AUTOSKIP_WS_HEADER, &on_syntax_error);
+    pj_scan_init(&scanner, buf, size, PJ_SCAN_AUTOSKIP_WS_HEADER, 
+                 &on_syntax_error);
+
+    context.scanner = &scanner;
+    context.pool = pool;
+    context.rdata = NULL;
 
     PJ_TRY {
 	pjsip_parse_hdr_func *handler = find_handler(hname);
 	if (handler) {
-	    hdr = (*handler)(&scanner, pool);
+	    hdr = (*handler)(&context);
 	} else {
-	    pjsip_generic_string_hdr *ghdr = parse_hdr_generic_string(&scanner, pool);
-	    ghdr->type = PJSIP_H_OTHER;
-	    pj_strdup(pool, &ghdr->name, hname);
-	    ghdr->sname = ghdr->name;
-	    hdr = (pjsip_hdr*)ghdr;
+	    hdr = parse_hdr_generic_string(&context);
+	    hdr->type = PJSIP_H_OTHER;
+	    pj_strdup(pool, &hdr->name, hname);
+	    hdr->sname = hdr->name;
 	}
 
@@ -1544,5 +1697,5 @@
 
     if (parsed_len) {
-	*parsed_len = (scanner.current - scanner.begin);
+	*parsed_len = (scanner.curptr - scanner.begin);
     }
 
Index: /pjproject/main/pjsip/src/pjsip/sip_resolve.c
===================================================================
--- /pjproject/main/pjsip/src/pjsip/sip_resolve.c	(revision 42)
+++ /pjproject/main/pjsip/src/pjsip/sip_resolve.c	(revision 43)
@@ -1,4 +1,3 @@
 /* $Id$
- *
  */
 
@@ -6,5 +5,6 @@
 #include <pjsip/sip_transport.h>
 #include <pj/pool.h>
-#include <ctype.h>
+#include <pj/ctype.h>
+#include <pj/assert.h>
 
 struct pjsip_resolver_t
@@ -22,5 +22,5 @@
 PJ_DEF(void) pjsip_resolver_destroy(pjsip_resolver_t *resolver)
 {
-    PJ_UNUSED_ARG(resolver)
+    PJ_UNUSED_ARG(resolver);
 }
 
@@ -31,5 +31,5 @@
 
     while (p != end) {
-	if (isdigit(*p) || *p=='.') {
+	if (pj_isdigit(*p) || *p=='.') {
 	    ++p;
 	} else {
@@ -51,6 +51,6 @@
     pjsip_transport_type_e type = target->type;
 
-    PJ_UNUSED_ARG(resolver)
-    PJ_UNUSED_ARG(pool)
+    PJ_UNUSED_ARG(resolver);
+    PJ_UNUSED_ARG(pool);
 
     /* We only do synchronous resolving at this moment. */
@@ -95,7 +95,9 @@
     /* Resolve hostname. */
     if (!is_ip_addr) {
-	status = pj_sockaddr_init(&svr_addr.entry[0].addr, &target->host, target->port);
+	status = pj_sockaddr_in_init(&svr_addr.entry[0].addr, &target->host, 
+				     (pj_uint16_t)target->port);
     } else {
-	status = pj_sockaddr_init(&svr_addr.entry[0].addr, &target->host, target->port);
+	status = pj_sockaddr_in_init(&svr_addr.entry[0].addr, &target->host, 
+				     (pj_uint16_t)target->port);
 	pj_assert(status == PJ_SUCCESS);
     }
